/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "vector"
#include "conflict_level.h"
#include "death_type.h"
#include "incident_hfid.h"
namespace df {
  struct incident_sub10;
  struct incident_sub6_performance;
  struct incident_sub7;
  struct incident_sub8;
  struct incident_sub9;
  struct DFHACK_EXPORT incident {
    int32_t id;
    enum T_type : int32_t {
      Combat, // 0, 0x0
      /**
       * Visible indirectly through convictions or crime effects (e.g. killing/maiming someone)
       */
      Crime, // 1, 0x1
      t2, // 2, 0x2
      t3, // 3, 0x3
      t4, // 4, 0x4
      t5, // 5, 0x5
      Performance, // 6, 0x6
      /**
       * Looks like quester, i.e. mercs looking for an artifact. Base on a single correlation of activities seen, though.
       */
      t7, // 7, 0x7
      t8, // 8, 0x8
      t9, // 9, 0x9
      t10, // 10, 0xA
    };
    T_type type;
    std::vector<int32_t > witnesses;
    int32_t unk_year;
    int32_t unk_year_tick;
    int32_t victim;
    df::incident_hfid victim_hf;
    int32_t victim_race; /*!< since v0.40.01 */
    int32_t victim_caste; /*!< since v0.40.01 */
    int32_t entity2; /*!< since v0.40.01; Seen with Crime */
    int32_t unk_v40_1c; /*!< since v0.40.01 */
    int32_t criminal;
    df::incident_hfid criminal_hf;
    int32_t criminal_race; /*!< since v0.40.01 */
    int32_t criminal_caste; /*!< since v0.40.01 */
    int32_t entity1; /*!< since v0.40.01 */
    df::incident_hfid unk_v40_2c;
    int32_t crime_id;
    int32_t site;
    int32_t unk_v40_3a; /*!< since v0.40.01; 41 seen on witnessed thief, 37 on interrogation target. Only one of each, though. */
    int32_t unk_v40_3b; /*!< since v0.40.01 */
    int32_t entity;
    int32_t event_year;
    int32_t event_time;
    union T_flags {
      uint32_t whole;
      struct {
        uint32_t announced_missing : 1;
        uint32_t discovered : 1;
        uint32_t unk2 : 1; /*!< since v0.40.01 */
      } bits;
      enum Shift {
        shift_announced_missing = 0,
        shift_discovered = 1,
        shift_unk2 = 2
      };
      enum Mask : uint32_t {
        mask_announced_missing = 0x1U,
        mask_discovered = 0x2U,
        mask_unk2 = 0x4U
      };
      T_flags(uint32_t whole_ = 0) : whole(whole_) {};
    };
    T_flags flags;
    df::death_type death_cause;
    df::conflict_level conflict_level;
    int32_t activity_id;
    int32_t world_x; /*!< Location appears to be in in-game tiles world wide */
    int32_t world_y;
    int32_t world_z;
    int32_t unk_80;
    union DFHACK_EXPORT T_data {
      df::incident_sub6_performance* t6_performance;
      df::incident_sub7* t7;
      df::incident_sub8* t8;
      df::incident_sub9* t9;
      df::incident_sub10* t10;
      T_data(){}
    };
    T_data data;
    static struct_identity _identity;
    typedef incident* key_pointer_type;
    typedef int32_t key_field_type;
    static int binsearch_index(const std::vector<incident*> &vec, key_field_type key, bool exact = true);
    static int binsearch_index(const std::vector<incident*> &vec, key_pointer_type key, bool exact = true);
    static std::vector<incident*> &get_vector();
    static std::vector<incident*> *get_vector_ptr();
    static incident *find(key_field_type id);
  public:
    incident();
  };
  template<> struct DFHACK_EXPORT identity_traits<incident::T_type> {
    static enum_identity identity;
    static enum_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT enum_traits<incident::T_type> {
    static const bool is_complex = false;
    typedef int32_t base_type;
    typedef incident::T_type enum_type;
    static const base_type first_item_value = 0;
    static const base_type last_item_value = 10;
    static inline bool is_valid(base_type value) {
      return (value >= first_item_value && value <= last_item_value);
    }
    static const enum_type first_item = (enum_type)first_item_value;
    static const enum_type last_item = (enum_type)last_item_value;
    static const char *const key_table[11];
  };
  template<> struct DFHACK_EXPORT bitfield_traits<incident::T_flags> {
    typedef uint32_t base_type;
    typedef incident::T_flags bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<incident::T_flags> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT identity_traits<incident::T_data> {
    static union_identity identity;
    static union_identity *get() { return &identity; }
  };
}
