/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "vector"
#include "coord2d.h"
#include "coord2d_path.h"
#include "entity_claim_mask.h"
#include "language_name.h"
#include "mountain_peak_flags.h"
namespace df {
  struct battlefield;
  struct breed;
  struct embark_note;
  struct feature_init;
  struct historical_entity;
  struct historical_figure;
  struct region_map_entry;
  struct region_weather;
  struct resource_allotment_data;
  struct world_construction;
  struct world_construction_square;
  struct world_geo_biome;
  struct world_landmass;
  struct world_object_data;
  struct world_region;
  struct world_region_details;
  struct world_river;
  struct world_site;
  struct world_site_unk130;
  struct world_underground_region;
  struct DFHACK_EXPORT world_data {
    df::language_name name; /*!< name of the world */
    int8_t unk1[15];
    int32_t next_site_id;
    int32_t next_site_unk130_id;
    int32_t next_resource_allotment_id;
    int32_t next_breed_id;
    int32_t next_battlefield_id; /*!< since v0.34.01 */
    int32_t unk_v34_1; /*!< since v0.34.01 */
    int32_t world_width;
    int32_t world_height;
    int32_t unk_78;
    int32_t moon_phase;
    enum T_flip_latitude : int16_t {
      None = -1, // -1, 0xFFFFFFFFFFFFFFFF
      North, // 0, 0x0
      South, // 1, 0x1
      Both, // 2, 0x2
    };
    T_flip_latitude flip_latitude;
    int16_t flip_longitude;
    int16_t unk_84;
    int16_t unk_86;
    int16_t unk_88;
    int16_t unk_8a;
    int16_t unk_v34_2; /*!< since v0.34.01 */
    int16_t unk_v34_3; /*!< since v0.34.01 */
    struct DFHACK_EXPORT T_unk_b4 {
      int32_t world_width2;
      int32_t world_height2;
      uint32_t* anon_1; /*!< align(width,4)*height */
      uint32_t* anon_2; /*!< align(width,4)*height */
      uint32_t* anon_3; /*!< width*height */
      uint8_t* anon_4; /*!< align(width,4)*height */
      static struct_identity _identity;
    public:
      T_unk_b4();
    };
    T_unk_b4 unk_b4;
    std::vector<df::world_region_details* > region_details;
    int32_t adv_region_x;
    int32_t adv_region_y;
    int32_t adv_emb_x;
    int32_t adv_emb_y;
    int16_t unk_x1;
    int16_t unk_y1;
    int16_t unk_x2;
    int16_t unk_y2;
    struct DFHACK_EXPORT T_constructions {
      int16_t width;
      int16_t height;
      std::vector<df::world_construction_square* >** map;
      std::vector<df::world_construction* > list;
      int32_t next_id;
      static struct_identity _identity;
    public:
      T_constructions();
    };
    T_constructions constructions;
    df::entity_claim_mask entity_claims1;
    df::entity_claim_mask entity_claims2;
    std::vector<df::world_site* > sites;
    std::vector<df::world_site_unk130* > site_unk130;
    std::vector<df::resource_allotment_data* > resource_allotments;
    std::vector<df::breed* > breeds;
    std::vector<df::battlefield* > battlefields; /*!< since v0.34.01 */
    std::vector<df::region_weather* > region_weather; /*!< since v0.34.01 */
    std::vector<df::world_object_data* > object_data; /*!< since v0.34.01 */
    std::vector<df::world_landmass* > landmasses;
    std::vector<df::world_region* > regions;
    std::vector<df::world_underground_region* > underground_regions;
    std::vector<df::world_geo_biome* > geo_biomes;
    struct DFHACK_EXPORT T_mountain_peaks {
      df::language_name name;
      df::coord2d pos;
      BitArray<df::mountain_peak_flags> flags;
      int16_t height;
      static struct_identity _identity;
    public:
      T_mountain_peaks();
    };
    std::vector<T_mountain_peaks* > mountain_peaks;
    std::vector<df::world_river* > rivers;
    df::region_map_entry** region_map;
    int8_t* unk_1c4;
    char unk_1c8[4];
    std::vector<df::embark_note* > embark_notes;
    std::vector<void* >** unk_1dc;
    std::vector<void* >** unk_1e0;
    std::vector<void* >** unk_1e4;
    std::vector<void* >** unk_1e8;
    std::vector<void* >** unk_1ec;
    std::vector<void* >** unk_1f0;
    int32_t anon_1; /*!< since v0.40.01 */
    void* anon_2; /*!< since v0.40.01 */
    void* anon_3; /*!< since v0.40.01 */
    void* anon_4; /*!< since v0.40.01 */
    void* anon_5; /*!< since v0.40.01 */
    void* anon_6; /*!< since v0.40.01 */
    void* anon_7; /*!< since v0.40.01 */
    void* anon_8; /*!< since v0.40.01 */
    void* anon_9; /*!< since v0.40.01 */
    void* anon_10; /*!< since v0.40.01 */
    void* anon_11; /*!< since v0.40.01 */
    void* anon_12; /*!< since v0.40.01 */
    void* anon_13; /*!< since v0.40.01 */
    void* anon_14; /*!< since v0.40.01 */
    void* anon_15; /*!< since v0.40.01 */
    void* anon_16; /*!< since v0.40.01 */
    char anon_17[294920];
    int8_t anon_18; /*!< since v0.40.01 */
    int8_t anon_19; /*!< since v0.40.01 */
    std::vector<df::world_site* > active_site;
    struct DFHACK_EXPORT T_feature_map {
      int16_t x;
      int16_t y;
      struct DFHACK_EXPORT T_features {
        std::vector<df::feature_init* > feature_init[16][16];
        int32_t unk[16][16][30];
        static struct_identity _identity;
      public:
        T_features();
      };
      T_features* features;
      int16_t* unk_8;
      int32_t* unk_c;
      static struct_identity _identity;
    public:
      T_feature_map();
    };
    /**
     * Additional feature_map information:
     * The feature_map is a two dimensional structure dividing the world into 16 * 16
     * world tile "feature shells" (and remember that there's a single tile wide shell
     * at the end of each dimension, so a pocket world has a shell dimension of 2 * 2).
     * These shells are loaded and unloaded dynamically, which means trying to access a
     * shell that isn't the one in DF's focus (where the fortress/adventurer/pre embark
     * cursor is) is invalid and can lead to DF crashing.
     * The "features.feature_init" 16 * 16 structure contains the features of each of
     * the corresponding world tiles within the shell. However, DF only loads the
     * feature vectors for the world tiles in focus, although they seem to remain
     * loaded until the shell is unloaded. Until loaded the vectors have a size of 0.
     * Manipulation of the features is usually preserved as feature vectors are
     * unloaded/reloaded, so spires can be elongated and rivers added, but some
     * details, such as river fauna, seem to be generated on loading. Added features
     * may not necessarily be reloaded at the vector index they were created at.
     */
    T_feature_map** feature_map;
    std::vector<int32_t > old_sites;
    std::vector<int32_t > old_site_x;
    std::vector<int32_t > old_site_y;
    df::coord2d_path land_rgns;
    int32_t unk_260;
    int8_t unk_264;
    int32_t unk_268;
    int8_t unk_26c;
    int32_t unk_270;
    struct DFHACK_EXPORT T_unk_274 {
      std::vector<df::historical_figure* > members;
      struct DFHACK_EXPORT T_unk_10 {
        int32_t unk_0;
        int32_t race;
        int32_t unk_8;
        static struct_identity _identity;
      public:
        T_unk_10();
      };
      std::vector<T_unk_10* > unk_10;
      df::historical_entity* entity;
      int32_t unk_24;
      df::language_name* unk_region_name;
      int32_t unk_2c;
      int32_t unk_30;
      static struct_identity _identity;
    public:
      T_unk_274();
    };
    std::vector<T_unk_274* > unk_274;
    /**
     * Since v0.40.01
     */
    struct DFHACK_EXPORT T_unk_482f8 {
      int32_t anon_1[320000];
      int32_t anon_2;
      int32_t anon_3;
      int32_t anon_4;
      int32_t anon_5;
      int32_t anon_6;
      int32_t anon_7;
      int32_t anon_8;
      static struct_identity _identity;
    public:
      T_unk_482f8();
    };
    T_unk_482f8 unk_482f8; /*!< since v0.40.01 */
    static struct_identity _identity;
  public:
    world_data();
  };
  template<> struct DFHACK_EXPORT identity_traits<world_data::T_flip_latitude> {
    static enum_identity identity;
    static enum_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT enum_traits<world_data::T_flip_latitude> {
    static const bool is_complex = false;
    typedef int16_t base_type;
    typedef world_data::T_flip_latitude enum_type;
    static const base_type first_item_value = -1;
    static const base_type last_item_value = 2;
    static inline bool is_valid(base_type value) {
      return (value >= first_item_value && value <= last_item_value);
    }
    static const enum_type first_item = (enum_type)first_item_value;
    static const enum_type last_item = (enum_type)last_item_value;
    static const char *const key_table[4];
  };
}
