/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "vector"
#include "coord2d.h"
namespace df {
  struct world_region_feature;
  struct DFHACK_EXPORT world_region_details {
    /**
     * biome field reference:
     * 789
     * 456
     * 123
     * as directions, with 5 = own world tile, 1 = SW, 9 = NE, etc.
     */
    int8_t biome[17][17];
    int16_t elevation[17][17];
    uint32_t seed[16][16]; /*!< looks random */
    /**
     * In order to determine how biomes cross embark tile edges,
     * the rectangle framing an embark tile is split into 4 corners,
     * and 4 straight edge segments, using ranges measured in tiles:
     * +-/----/+
     * |       /
     * /   *   |
     * /       /
     * +-/-/---+
     * After this, each corner and edge segment is assigned the biome
     * of one of the adjoining 4 or 2 embark tiles, based on the values
     * in these arrays. It may be necessary to access adjacent details
     * objects to collect the full outline:
     * c11 x11 | c21
     * y11 *** | y21
     * -------------
     * c12 x12 | c22
     * There are also certain rules forcing ocean/lake biomes to lose
     * edges to mountains, and both of them to anything else, no matter
     * what the original array value is. The actual biomes for tiles in
     * the frame are semi-randomly interpolated from this edge spec.
     * For some reason DF provides for all edges of all mid level tiles
     * in a world tile, but not for the corners on the south and east
     * edges: for these you have to go to the next world tile.
     * This has some effect on the corners on the south and east edges of
     * the world where there are no adjacent tiles to get the data from.
     * There the rules are static: the biomes of corners are taken from
     * the easternmost and southernmost of the two touching corners.
     * The rules for corner determination when the biome_corner field has
     * specified a biome that's specified to yield as per the above seems
     * to be to first take the NW corner (0), then the NE (1) one, and
     * then the SW (2) one. If the selected corner doesn't exist (because
     * it's outside of the world) the same fallback corner selection is
     * used, with the exception of a northern row selection of NW (0),
     * where the home corner (3) is selected.
     */
    struct DFHACK_EXPORT T_edges {
      df::coord2d split_x[16][17]; /*!< splits for horizontal edges, x=min y=max */
      df::coord2d split_y[17][16]; /*!< splits for vertical edges, x=min y=max */
      /**
       * All 4 corners touching get the same reference (which determines the biome),
       * i.e. SE corner of the tile to the NW, SW corner of the tile to the
       * N, NE corner of the tile to the W, and the NW corner of the current
       * tile, as directed by the biome_corner value.
       */
      int8_t biome_corner[16][16]; /*!< 0=Reference is NW, 1=Reference is N, 2=Reference is W, 3=Reference is current tile */
      int8_t biome_x[16][16]; /*!< 0=Reference is N, 1=Reference is current tile (adopted by S edge to the N) */
      int8_t biome_y[16][16]; /*!< 0=Reference is W, 1=Reference is current tile (Adopted by E edge to the W) */
      static struct_identity _identity;
    public:
      T_edges();
    };
    /**
     * In order to determine how biomes cross embark tile edges,
     * the rectangle framing an embark tile is split into 4 corners,
     * and 4 straight edge segments, using ranges measured in tiles:
     * +-/----/+
     * |       /
     * /   *   |
     * /       /
     * +-/-/---+
     * After this, each corner and edge segment is assigned the biome
     * of one of the adjoining 4 or 2 embark tiles, based on the values
     * in these arrays. It may be necessary to access adjacent details
     * objects to collect the full outline:
     * c11 x11 | c21
     * y11 *** | y21
     * -------------
     * c12 x12 | c22
     * There are also certain rules forcing ocean/lake biomes to lose
     * edges to mountains, and both of them to anything else, no matter
     * what the original array value is. The actual biomes for tiles in
     * the frame are semi-randomly interpolated from this edge spec.
     * For some reason DF provides for all edges of all mid level tiles
     * in a world tile, but not for the corners on the south and east
     * edges: for these you have to go to the next world tile.
     * This has some effect on the corners on the south and east edges of
     * the world where there are no adjacent tiles to get the data from.
     * There the rules are static: the biomes of corners are taken from
     * the easternmost and southernmost of the two touching corners.
     * The rules for corner determination when the biome_corner field has
     * specified a biome that's specified to yield as per the above seems
     * to be to first take the NW corner (0), then the NE (1) one, and
     * then the SW (2) one. If the selected corner doesn't exist (because
     * it's outside of the world) the same fallback corner selection is
     * used, with the exception of a northern row selection of NW (0),
     * where the home corner (3) is selected.
     */
    T_edges edges;
    df::coord2d pos;
    int16_t unk12e8;
    int16_t anon_1;
    int16_t anon_2;
    int16_t anon_3;
    int16_t anon_4;
    struct DFHACK_EXPORT T_rivers_vertical {
      int16_t x_min[16][17];
      int16_t x_max[16][17];
      int8_t active[16][17];
      int16_t elevation[16][17];
      static struct_identity _identity;
    public:
      T_rivers_vertical();
    };
    T_rivers_vertical rivers_vertical;
    struct DFHACK_EXPORT T_rivers_horizontal {
      int16_t y_min[17][16];
      int16_t y_max[17][16];
      int8_t active[17][16];
      int16_t elevation[17][16];
      static struct_identity _identity;
    public:
      T_rivers_horizontal();
    };
    T_rivers_horizontal rivers_horizontal;
    union T_other_features {
      uint8_t whole;
      struct {
        uint8_t construction : 1; /*!< the MLTs of world_data.constructions.all */
        uint8_t minor_site_footprint : 1; /*!< MLTs with sites other than MountainHall, DarkFortress, ForestRetreat, Town */
        uint8_t river : 1; /*!< Only a very small subset (selection criteria unknown), but the MLTs marked match up with Rivers* tiles plus implicit River tiles interpolated from that */
      } bits;
      enum Shift {
        shift_construction = 0,
        shift_minor_site_footprint = 1,
        shift_river = 2
      };
      enum Mask : uint8_t {
        mask_construction = 0x1U,
        mask_minor_site_footprint = 0x2U,
        mask_river = 0x4U
      };
      T_other_features(uint8_t whole_ = 0) : whole(whole_) {};
    };
    T_other_features other_features[16][16];
    std::vector<df::world_region_feature* > features[16][16];
    int16_t lava_stone;
    int16_t unk_12[1152]; /*!< since v0.40.01; Might it be 256 * 9 int8_t, i.e. 1 per 16*16 block?. Never seen other than -1, though */
    int16_t elevation2[16][16];
    int32_t undef13[256];
    static struct_identity _identity;
  public:
    world_region_details();
  };
  template<> struct DFHACK_EXPORT bitfield_traits<world_region_details::T_other_features> {
    typedef uint8_t base_type;
    typedef world_region_details::T_other_features bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<world_region_details::T_other_features> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
}
